[!if=(FreeThreadedMarshaler, "TRUE")]
	[!set(NeedsGetControllingUnknown, "TRUE")]
[!endif]
// [!HeaderName] : Declaration of the [!ClassName]
[!crlf]

[!if=(FileExists, "FALSE")]
#ifndef __[!UpperShortName]_H_
#define __[!UpperShortName]_H_
[!crlf]

#include "resource.h"       // main symbols
[!crlf]
// includes from BizTalk SDK from "Program Files\Microsoft BizTalk Server\SDK\Include"
#include <BTSParserComps.h>     // for IBizTalkParserComponent interface
#include <bts_sdk_guids.h>      // for guids for interfaces and categories
#include <biztalkobjectmodel.h> // for IBizTalkConfig interfaces
[!crlf]
// includes from STL
#include <vector>
[!else]
[!AddIncludeFile(TargetFile, "resource.h")]
[!AddIncludeFile(TargetFile, "BTSParserComps.h")]
[!AddIncludeFile(TargetFile, "bts_sdk_guids.h")]
[!AddIncludeFile(TargetFile, "biztalkobjectmodel.h")]
[!AddIncludeFile(TargetFile, "vector")]
[!endif]

[!crlf]
#ifndef _CPPUNWIND
#pragma message("***************************************************************************************************")
#pragma message("*** Exception handling must be enabled for the STL classes used here.")
#pragma message("***************************************************************************************************")
#endif

[!crlf]
[!crlf]

[!crlf]
/////////////////////////////////////////////////////////////////////////////
// [!ClassName]

class ATL_NO_VTABLE [!ClassName] : 
[!if=(ThreadingModel, "Single")]
	public CComObjectRootEx<CComSingleThreadModel>,
[!endif]
[!if=(ThreadingModel, "Apartment")]
	public CComObjectRootEx<CComSingleThreadModel>,
[!endif]
[!if=(ThreadingModel, "Both")]
	public CComObjectRootEx<CComMultiThreadModel>,
[!endif]
[!if=(ThreadingModel, "Free")]
	public CComObjectRootEx<CComMultiThreadModel>,
[!endif]
	public CComCoClass<[!ClassName], &CLSID_[!CoClassName]>,
[!if=(ErrorInfoEnabled, "TRUE")]
	public ISupportErrorInfo,
[!endif]
[!if=(ConnectionPointsEnabled, "TRUE")]
	public IConnectionPointContainerImpl<[!ClassName]>,
[!endif]
[!if=(ConnectionPointsEnabled, "TRUE")]
[!if=(IPROVIDECLASSINFO2, "TRUE")]
	public IProvideClassInfo2Impl<&CLSID_[!CoClassName], &DIID__[!InterfaceName]Events, &LIBID_[!LibName]>,
[!endif]
[!if=(IPROPERTYNOTIFYSINK, "TRUE")]
	public IPropertyNotifySinkCP<[!ClassName]>,
[!endif]
[!else]
[!if=(IPROVIDECLASSINFO2, "TRUE")]
	public IProvideClassInfo2Impl<&CLSID_[!CoClassName], [!ConnectionPointInterface], &LIBID_[!LibName]>,
[!endif]
[!endif]
[!if=(Dual, "TRUE")]
	public IDispatchImpl<[!InterfaceName], &IID_[!InterfaceName], &LIBID_[!LibName]>,
[!else]
	public [!InterfaceName],
[!endif]
    public IBizTalkParserComponent
{
public:
	[!ClassName]()
	{
[!if=(FreeThreadedMarshaler, "TRUE")]
		m_pUnkMarshaler = NULL;
[!endif]
	}

[!crlf]
DECLARE_REGISTRY_RESOURCEID([!IDR_REGISTRYID])

[!if=(Aggregatable, "NO")]
DECLARE_NOT_AGGREGATABLE([!ClassName])
[!endif]
[!if=(Aggregatable, "ONLY")]
DECLARE_ONLY_AGGREGATABLE([!ClassName])
[!endif]

[!if=(NeedsGetControllingUnknown, "TRUE")]
DECLARE_GET_CONTROLLING_UNKNOWN()
[!endif]
[!crlf]
DECLARE_PROTECT_FINAL_CONSTRUCT()

[!crlf]
// BizTalk requires a COM category for custom parsers
//         and a COM category for each BizTalk component
BEGIN_CATEGORY_MAP([!ClassName])
	IMPLEMENTED_CATEGORY(CATID_BIZTALK_COMPONENT)
    IMPLEMENTED_CATEGORY(CATID_BIZTALK_PARSER)
END_CATEGORY_MAP()

[!crlf]
BEGIN_COM_MAP([!ClassName])
	COM_INTERFACE_ENTRY(IBizTalkParserComponent)
	COM_INTERFACE_ENTRY([!InterfaceName])
[!if=(ErrorInfoEnabled, "TRUE")]
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
[!endif]
[!if=(ConnectionPointsEnabled, "TRUE")]
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
[!endif]
[!if=(FreeThreadedMarshaler, "TRUE")]
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
[!endif]
[!if=(IPROVIDECLASSINFO2, "TRUE")]
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
[!endif]
END_COM_MAP()

[!if=(ConnectionPointsEnabled, "TRUE")]
BEGIN_CONNECTION_POINT_MAP([!ClassName])
[!if=(IPROPERTYNOTIFYSINK, "TRUE")]
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
[!endif]
END_CONNECTION_POINT_MAP()
[!crlf]
[!endif]

[!if=(FreeThreadedMarshaler, "TRUE")]
[!crlf]
	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

[!crlf]
	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

[!crlf]
	CComPtr<IUnknown> m_pUnkMarshaler;
[!endif]

[!if=(ErrorInfoEnabled, "TRUE")]
[!crlf]
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);
[!endif]

[!crlf]
// IBizTalkParserComponent interface
public:
	STDMETHOD(ProbeInterchangeFormat)(IStream * pstmData, BOOL bFromFile, BSTR bstrEnvName, IStream * pstmReceiptData, BSTR * pbstrFormat);
	STDMETHOD(GetInterchangeDetails)(IDictionary * pdict);
	STDMETHOD(GroupsExist)(BOOL * pbGroupsExist);
	STDMETHOD(GetGroupDetails)(IDictionary * pdict);
	STDMETHOD(GetGroupSize)(long * pnGroupSize, BOOL * pbLastGroup);
	STDMETHOD(GetNextDocument)(IDictionary * pdict, BSTR bstrDocName, BOOL * pbDocIsValid, BOOL * pbLastDocument, enum GeneratedReceiptLevel * pnReceiptGenerated, BOOL * pbDocIsReceipt, BSTR * pbstrCorrelationCompProgID);
	STDMETHOD(GetNativeDocumentOffsets)(BOOL * pbSizeFromXMLDoc, LARGE_INTEGER * pnStartOffset, long * pnDocLength);

[!crlf]
private:
    CComPtr<IStream> m_spstmData;       // holds stream for data to parse; initialized in ProbeInterchangeFormat()
    CComPtr<IBizTalkConfig> m_spconfig; // holds config interface; initialized in ProbeInterchangeFormat()

[!crlf]
// [!InterfaceName]
public:
};

[!crlf]
[!if=(FileExists, "FALSE")]
#endif //__[!UpperShortName]_H_
[!endif]
