[!if=(FileExists, "FALSE")]
// [!CPPName] : Implementation of [!ClassName]

#include "stdafx.h"
#include "[!ProjectName].h"
#include "[!HeaderName]"
[!else]
[!AddIncludeFile(TargetFile, "stdafx.h")]
[!AddStringToSymbol(ProjectName.h, ProjectName, ".h")]
[!AddIncludeFile(TargetFile, ProjectName.h)]
[!AddIncludeFile(TargetFile, HeaderName)]
[!endif]
[!crlf]
#import "msxml3.dll" rename_namespace("XMLDOM"), raw_interfaces_only

/////////////////////////////////////////////////////////////////////////////
// [!ClassName]
[!crlf]
[!if=(ErrorInfoEnabled, "TRUE")]
STDMETHODIMP [!ClassName]::InterfaceSupportsErrorInfo(REFIID riid)
{
    static const IID* arr[] = 
    {
        &IID_[!InterfaceName]
    };

    for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
    {
        if (InlineIsEqualGUID(*arr[i],riid))
            return S_OK;
    }
    return S_FALSE;
}
[!endif]


[!crlf]
[!crlf]
/////////////////////////////////////////////////////////////////////////////
// Stream helpers
//   loadStream() -- loads data from a stream in dynamically allocated buffer
//   peekStream() -- just like loadStream() but doesn't change current read position
//
//  Both return dynamically allocated buffers.  Caller frees using operator delete[].
//  Both accept nRequestedSize which can be (size_t)-1 to get entire stream.
//  Both have an optional 3rd parameter for the number of bytes actual read.
//
static BYTE * loadStream ( IStream * pstm, size_t nRequestedSize, size_t & nActualSize )
{
    nActualSize = 0; // default value for output parameter
    if (! pstm) return 0;
[!crlf]
    // determine the entire stream size, if no size is provided
    if (nRequestedSize == (size_t)-1)
    {
        STATSTG stat; 
        memset(&stat, 0, sizeof stat);
        if (FAILED(pstm->Stat(&stat, STATFLAG_NONAME))) return 0;
        nRequestedSize = (size_t)stat.cbSize.QuadPart;
    }
[!crlf]
    // allocate a buffer and clear to zero
    BYTE * buffer = new unsigned char[2 + nRequestedSize];
    memset(buffer, 0, 2+nRequestedSize); // extra L'\0' in case being null-terminated is useful
[!crlf]
    // read in the buffer and record how many bytes actually read
    ULONG nBytesRead = 0;
    HRESULT hr = pstm->Read(buffer, (ULONG)nRequestedSize, &nBytesRead);
    if (FAILED(hr))
    {
        delete[] buffer;
        buffer = 0;
    }
[!crlf]
    // set the number of bytes actually read
    if (buffer)
        nActualSize = (size_t) nBytesRead;
    return buffer;
}
static BYTE * loadStream ( IStream * pstm, size_t nRequestedSize = (size_t) -1 /* defaults to entire stream size */ )
{
    size_t nUnused;
    return loadStream(pstm, nRequestedSize, nUnused);
}
[!crlf]
static BYTE * peekStream ( IStream * pstm, size_t nPeek, size_t & nPeeked )
{
    // load the requested number of bytes from the stream
    BYTE * buffer = loadStream(pstm, nPeek, nPeeked);
[!crlf]
    // restore read position so the read is really a peek
    if (buffer && (nPeeked > 0))
    {
        LARGE_INTEGER nOffset; nOffset.QuadPart = - (LONGLONG)nPeeked;
        ATLASSERT(SUCCEEDED(pstm->Seek(nOffset, STREAM_SEEK_CUR, 0)));
    }
    return buffer;
}
[!crlf]
static BYTE * peekStream ( IStream * pstm, size_t nPeek = (size_t) -1 /* defaults to entire stream size */ )
{
    size_t nUnused;
    return peekStream(pstm, nPeek, nUnused);
}
[!crlf]
[!crlf]
/////////////////////////////////////////////////////////////////////////////
// ATLTRACE helpers
//   _TRACER(x) -- returns a non-null string value for various types x.
//                 The return type is either BSTR or CComBSTR.
//   _AtlTraceBigBufer() -- a replacement for ATL's ATLTRACE mechanism
//                 which has a limit of 512 chars and fires an assert
//                 if the message is greater than 512.  Firing an 
//                 assert message box inside a component loaded into a 
//                 service is not good.
#ifdef _DEBUG
#undef ATLTRACE
#define ATLTRACE _AtlTraceBigBuffer

void _AtlTraceBigBuffer ( LPCTSTR pszFormat, ... )
{
    const size_t nSize = 8192;
    TCHAR * sz = new TCHAR[nSize];
    memset(sz, 0, nSize);
    va_list args;
    va_start(args, pszFormat);
    _vsntprintf(sz, nSize-1, pszFormat, args);
    va_end(args);
    OutputDebugString(sz); //would call ATLTRACE but szReg is > 512 bytes
    delete[] sz;
}
static BSTR _TRACER ( BSTR s )
{
    return s ? s : L"";
}

static CComBSTR _TRACER ( IStream * pstm, size_t nPrefixLen = 50 ) // nPrefixLen = how many bytes of the stream prefix should be returned
{
    if (! pstm) return L"<null>";
    wchar_t wsz[4096];
    wcscpy(wsz, L"{size:");
    STATSTG stat;
    memset(&stat, 0, sizeof stat);
    if (SUCCEEDED(pstm->Stat(&stat, STATFLAG_NONAME)))
        swprintf(wsz+wcslen(wsz), L"%I64u", stat.cbSize.QuadPart);
    else
        wcscat(wsz, L"<unavailable>");
    if (nPrefixLen)
    {
        wcscat(wsz, L" data:");
        // peek at data; get 1 more byte than nPrefixLen so can test if there is more data
        size_t nBytesRead;
        char * pszData = (char *)peekStream(pstm, nPrefixLen+1, nBytesRead);
        bool bMoreData = (nBytesRead > nPrefixLen);
        if (bMoreData) -- nBytesRead; // don't use the extra byte read just for testing purposes
        if (! pszData)
            wcscat(wsz, L"<unavailable>");
        else
        {
            wcscat(wsz, L"\"");
            for ( int i = 0;  i < (int)nBytesRead;  ++i )
                if (isprint((unsigned char)pszData[i]))
                    swprintf(wsz+wcslen(wsz), L"%C", pszData[i]);
                else
                    switch (pszData[i])
                    {
                        case '\0': wcscat(wsz, L"\\0"); break;
                        case '\r': wcscat(wsz, L"\\r"); break;
                        case '\n': wcscat(wsz, L"\\n"); break;
                        case '\t': wcscat(wsz, L"\\t"); break;
                        case '\"': wcscat(wsz, L"\\\""); break;
                        default:   swprintf(wsz+wcslen(wsz), L"\\x%02X", (int)(unsigned char)pszData[i]); break;
                    }
            if (bMoreData) wcscat(wsz, L"...");
            wcscat(wsz, L"\"");
        }
        delete[] (BYTE*)pszData;
    }
    wcscat(wsz, L"}");
    return wsz;
}
[!crlf]
static CComBSTR _TRACER ( IDictionary * pdict )
{
    if (! pdict) return L"<null>";
    // get the number of items in the dictionary
    wchar_t wsz[8192];
    wcscpy(wsz, L"{count:");
    long nCount = 0;
    if (FAILED(pdict->get_Count(&nCount)))
        wcscat(wsz, L"<unavailable>");
    else
    {
        swprintf(wsz+wcslen(wsz), L"%ld", nCount);
        if (nCount > 0) 
        {
            wcscat(wsz, L" items:");
            CComPtr<IUnknown> spunkEnum;
            if (FAILED(pdict->get__NewEnum(&spunkEnum))) spunkEnum = 0;
            CComQIPtr<IEnumVARIANT> spEnum(spunkEnum);
            if (! spEnum)
                wcscat(wsz, L"<unavailable>");
            else
                for ( ;; )
                {
                    CComVariant vaKey, vaValue;
                    if (S_OK != spEnum->Next(1, &vaKey, 0)) break;
                    if (FAILED(vaKey.ChangeType(VT_BSTR))) continue;
                    swprintf(wsz+wcslen(wsz), L"[%ls]=", vaKey.bstrVal ? vaKey.bstrVal : L"");
                    if (SUCCEEDED(pdict->get_Value(vaKey.bstrVal, &vaValue)) && SUCCEEDED(vaValue.ChangeType(VT_BSTR)))
                        swprintf(wsz+wcslen(wsz), L"\"%ls\" ", vaValue.bstrVal ? vaValue.bstrVal : L"");
                    else
                        wcscat(wsz, L"<unavailable>");
                }
        }
    }
    wcscat(wsz, L"}");
    return wsz;
}
#endif
[!crlf]
[!crlf]

[!crlf]
/////////////////////////////////////////////////////////////////////////////
// IBizTalkSerializer implementation
//

[!crlf]
// IBizTalkSerializer::Init()
// --------------------------
//  receive the output stream to use during serializing.  Also, receive the number of
//  documents in the interchange.  For BizTalk 2002, this number is always 1.
//
//  Called before any other member of this interface.
//
//  on input,
//      bstrSourceQualifier = qualifier part of the source organization
//      bstrSourceID = identier part of the source organization
//      bstrDestinationQualifier = qualifier part of the destination organization
//      bstrDestinationID = identier part of the destination organization
//      nEnvelopeID = identifier for the envelope used in the channel
//      pdictDelimiters = dictionary containing any delimiters used for serialization
//      pstmOutput = stream into which to write all output
//      nNumDocs = number of documents in the interchange.  Will always be 1 in BizTalk 2002.
//      nPortID = identifier for the port to which this channel using this serializer is connected
//
//  return value
//      is S_OK on success and a negative HRESULT otherwise
//
//  implementation note:
//      Per the BizTalk documention, pstmOutput is addrefed and stored.
//
STDMETHODIMP [!ClassName]::Init(BSTR bstrSourceQualifier, BSTR bstrSourceID, BSTR bstrDestinationQualifier, BSTR bstrDestinationID,
                                long nEnvelopeID, IDictionary * pdictDelimiters, IStream * pstmOutput, long nNumDocs, long nPortID)
{
    ATLTRACE(_T("\nEnter IBizTalkSerializer::Init([in] bstrSourceQualifier=\"%ls\", [in] bstrSourceID=\"%ls\", [in] bstrDestinationQualifier=\"%ls\", [in] bstrDestinationID=\"%ls\", ")
             _T("[in] nEnvelopeID=%ld, [in] pdictDelimiters=%ls, [in] nNumDocs=%ld, [in] nPortID=%ld)\n"),
             (BSTR)_TRACER(bstrSourceQualifier), (BSTR)_TRACER(bstrSourceID), (BSTR)_TRACER(bstrDestinationQualifier), (BSTR)_TRACER(bstrDestinationID), 
             nEnvelopeID, (BSTR)_TRACER(pdictDelimiters), nNumDocs, nPortID);
    if (!pdictDelimiters || !pstmOutput) 
    {
        ATLTRACE("\nExit IBizTalkSerializer::Init(), return E_POINTER\n");
        ATLASSERT(0);
        return E_POINTER;
    }
[!crlf]
    // in BizTalk 2002 release, number of documents should be exactly 1
    if (nNumDocs != 1) 
    {
        ATLTRACE("\nExit IBizTalkSerializer::Init(), return E_NOTIMPL\n");
        ATLASSERT(0);
        return E_NOTIMPL;
    }

[!crlf]
    // acquire the biztalk configuration interface
    HRESULT hr = m_spconfig.CoCreateInstance(L"BizTalk.BizTalkConfig");
    ATLASSERT(SUCCEEDED(hr) && m_spconfig.p);
    if (FAILED(hr)) return E_FAIL;

[!crlf]
    // TBD:  acquire IBizTalkOrganization interfaces from IBizTalkConfig
    // TBD:  acquire IBizTalkEnvelope interface from IBizTalkConfig
    // TBD:  acquire IBizTalkEnvelope interface from IBizTalkConfig
    // TBD:  acquire IBizTalkPort interface using IBizTalkConfig

[!crlf]
    // cache the output stream for later use
    m_spstmOutput = pstmOutput;
    ATLTRACE("\nExit IBizTalkSerializer::Init(), return S_OK\n");
    return S_OK;
}

[!crlf]
// IBizTalkSerializer::AddDocument()
// ---------------------------------
//  serialize the given document to the output stream passed into the 
//  this serializer by the Init() function.
//
//  on input,
//      nDocHandle = an integer handle to associated with this document.
//                   When documents are grouped using GetGroupInfo() and GetDocInfo(),
//                   a document will be identified by its handle.
//      pdictTransport = the transport dictionary containing the the XML document to
//                       serialize under the dictionary key "working_data".  Remember
//                       that keys in IDictionary are not case sensitive.
//      bstrTrackID = id used in the tracking database for this document
//      nChannelID = id of the channel in which this custom serializer is being used
//
//  return value
//      is S_OK on success and a negative HRESULT otherwise
//
STDMETHODIMP [!ClassName]::AddDocument(long nDocHandle, IDictionary * pdictTransport, BSTR bstrTrackID, long nChannelID)
{
    ATLTRACE(_T("\nEnter IBizTalkSerializer::AddDocument([in] nDocHandle=%ld, [in] pdictTransport=%ls, [in] bstrTrackID=\"%ls\", [in] nChannelID=%ld)\n"), 
                  nDocHandle, (BSTR)_TRACER(pdictTransport), (BSTR)_TRACER(bstrTrackID), nChannelID);
    if (! pdictTransport) 
    {
        ATLTRACE("\nExit IBizTalkSerializer::AddDocument(), return E_POINTER\n");
        ATLASSERT(0);
        return E_POINTER;
    }
[!crlf]
    // get the XML document from the transport dictionary
    CComPtr<XMLDOM::IXMLDOMDocument2> spxml;
    VARIANT_BOOL bLoaded;
    CComVariant vaKey(L"working_data"), vaDocument;
    HRESULT hr = pdictTransport->get_Value(vaKey.bstrVal, &vaDocument);
    if (SUCCEEDED(hr)) hr = vaDocument.ChangeType(VT_BSTR);
    if (SUCCEEDED(hr)) hr = spxml.CoCreateInstance(__uuidof(XMLDOM::DOMDocument30));
    if (SUCCEEDED(hr)) hr = spxml->loadXML(vaDocument.bstrVal, &bLoaded);
    if (FAILED(hr) || (bLoaded == VARIANT_FALSE))
    {
        ATLTRACE("\nExit IBizTalkSerializer::AddDocument(), return E_FAIL\n");
        ATLASSERT(0);
        return E_FAIL;
    }
[!crlf]
    // write the document to the output stream (data member m_spstmOutput)
#pragma message("TBD: Custom Serializer:  Serialize the given document in IBizTalkSerializer::AddDocument()")
[!crlf]
    // store the document handle and size for use by GetDocInfo()
    //     Because BizTalk 2002 is limited to only one document in the interchange, we
    //     do not need to store a list of handles and sizes.  Single data members are enough.
    m_nDocHandle = nDocHandle;
    m_nDocSize = 0;
#pragma message("TBD: Custom Serializer:  Record document size in IBizTalkSerializer::AddDocument()")
[!crlf]
    ATLTRACE(_T("\nExit IBizTalkSerializer::AddDocument([out] pdictTransport=%ls), return S_OK\n"), (BSTR)_TRACER(pdictTransport));
    return S_OK;
}

[!crlf]
// IBizTalkSerializer::GetInterchangeInfo()
// ----------------------------------------
//  get information about the interchange.  This function is called after all documents
//  have been serialized.
//
//  on output,
//      pbstrInterchangeID = an identifer for the exchange to appear in the tracking database
//      pnNumGroups = number of groups in the interchange.  Must be 0 or 1 for BizTalk 2002.
//
//  return value
//      is S_OK on success and a negative HRESULT otherwise
//
STDMETHODIMP [!ClassName]::GetInterchangeInfo(BSTR * pbstrInterchangeID, long * pnNumGroups)
{
    ATLTRACE(_T("\nEnter IBizTalkSerializer::GetInterchangeInfo()\n"));
    if (!pbstrInterchangeID || !pnNumGroups) 
    {
        ATLTRACE("\nExit IBizTalkSerializer::GetInterchangeInfo(), return E_POINTER\n");
        ATLASSERT(0);
        return E_POINTER;
    }
[!crlf]
    // allocate an id to go in the tracking database
    GUID guid;
    wchar_t wszGuid[128];
    if (FAILED(CoCreateGuid(&guid)))
    {
        ATLTRACE("\nExit IBizTalkSerializer::GetInterchangeInfo(), return E_FAIL\n");
        ATLASSERT(0);
        return E_FAIL;
    }
    StringFromGUID2(guid, wszGuid, sizeof wszGuid);
    *pbstrInterchangeID = CComBSTR(wszGuid).Detach();
[!crlf]
    // set number of groups in the interchange (must be 0 or 1 for BizTalk 2002)
    *pnNumGroups = 0;
#pragma message("TBD: Custom Serializer:  Set number of groups in IBizTalkSerializer::GetInterchangeInfo()")
[!crlf]
    ATLASSERT((*pnNumGroups == 0) || (*pnNumGroups == 1)); // required for BizTalk 2002
    ATLTRACE(_T("\nExit IBizTalkSerializer::GetInterchangeInfo([out] pbstrInterchangeID=\"%ls\", [out] pnNumGroups=%ld), return S_OK\n"), 
                    (BSTR)_TRACER(*pbstrInterchangeID), *pnNumGroups);
    return S_OK;
}

[!crlf]
// IBizTalkSerializer::GetGroupInfo()
// ----------------------------------
//  get information about next group for the tracking database.
//
//  on output,
//      pnNumDocs = number of documents in the next group
//      pnGroupStartOffset = offset into the output stream for the start of the group
//                         = ofset to the first document in the group
//      pnGroupLen = total number of bytes in the group
//                 = total number of bytes in all documents in the group
//
//  return value
//      is S_OK on success and a negative HRESULT otherwise.
//      E_UNEXPECTED is returned if GetInterchangeInfo() specifies zero groups.
// 
STDMETHODIMP [!ClassName]::GetGroupInfo(long * pnNumDocs, LARGE_INTEGER * pnGroupStartOffset, long * pnGroupLen)
{
    ATLTRACE(_T("\nEnter IBizTalkSerializer::GetGroupInfo()\n"));
    if (!pnNumDocs || !pnGroupStartOffset || !pnGroupLen) 
    {
        ATLTRACE("\nExit IBizTalkSerializer::GetGroupInfo(), return E_POINTER\n");
        ATLASSERT(0);
        return E_POINTER;
    }
    ATLTRACE(_T("\nExit IBizTalkSerializer::GetGroupInfo([out] pnNumDocs=%ld, [out] pnGroupStartOffset=%I64d, [out] pnGroupLen), return E_NOTIMPL\n"), 
                    *pnNumDocs, pnGroupStartOffset->QuadPart, *pnGroupLen);
    return E_NOTIMPL;
}

[!crlf]
// IBizTalkSerializer::GetDocInfo()
// --------------------------------
//  get information about next document for the tracking database.
//
//  on output,
//      pnDocHandle = handle for the next document in the group; this handle value
//                    was match one of the values passed into AddDocument()
//      pbSizeFromXMLDoc = offset into the output stream for the start of the group
//                         = ofset to the first document in the group
//      pbSizeFromXMLDoc = TRUE,  if BizTalk should infer the size and position.  In this case,
//                                the last 2 output parameters are not used.
//                         FALSE, if the size and position are specifed in the last 2 output parameters.
//
//                         Inference is done based on the XML returned from GetNextDocument().
//      pnDocStartOffset = the offset within the stream for the start of the document
//                         set only if pbSizeFromXMLDoc is set to FALSE
//      pnDocLen = the size within the stream for the start of the document's data in the unparsed form
//                    set only if pbSizeFromXMLDoc is set to FALSE
//
//  return value
//      is S_OK on success and a negative HRESULT otherwise
//
STDMETHODIMP [!ClassName]::GetDocInfo(long * pnDocHandle, BOOL * pbSizeFromXMLDoc, LARGE_INTEGER * pnDocStartOffset, long * pnDocLen)
{
    ATLTRACE(_T("\nEnter IBizTalkSerializer::GetDocInfo()\n"));
    if (!pnDocHandle || !pbSizeFromXMLDoc || !pnDocStartOffset || !pnDocLen) 
    {
        ATLTRACE("\nExit IBizTalkSerializer::GetDocInfo(), return E_POINTER\n");
        ATLASSERT(0);
        return E_POINTER;
    }
[!crlf]
    // set the document handle and size to the value stored in AddDocument()
    *pnDocHandle = m_nDocHandle;
    *pnDocLen = m_nDocSize;
[!crlf]
    // set the document offset which is 0 because there is only 1 document in the interchange    
    pnDocStartOffset->QuadPart = 0;
[!crlf]
    // flag that we sent the size and offset here
    *pbSizeFromXMLDoc = FALSE;
[!crlf]
    ATLTRACE(_T("\nExit IBizTalkSerializer::GetDocInfo([out] pnDocHandle=%ld, [out] pbSizeFromXMLDoc=%ld, [out] pnDocStartOffset=%I64u, [out] pnDocLen=%ld), return E_NOTIMPL\n"), *pnDocHandle, *pbSizeFromXMLDoc, pnDocStartOffset->QuadPart, *pnDocLen);
    return S_OK;;
}
