// Selector.cpp : Implementation of CSelector
#include "stdafx.h"
#include "SelectorFunctoid.h"
#include "Selector.h"

/////////////////////////////////////////////////////////////////////////////
// CSelector


#define _VERSION 1
BEGIN_FUNCTOID_MAP(CSelector, _VERSION, FUNCTOID_FIRST_USER_FUNCID)
   BEGIN_FUNCTOID(L"Selector", FUNC_CATEGORY_UNKNOWN)
        FUNCTOID_TOOLTIP(L"Select one value from a list of values.")
        FUNCTOID_BITMAP(IDB_FUNCTOID_SELECTOR)   // have one FUNCTOID_BITMAP entry for the tool palette image
        FUNCTOID_OUT(CONNECT_TYPE_ALL)              // have one FUNCTOID_OUT entry for output parameter
        FUNCTOID_IN(CONNECT_TYPE_ALL_EXCEPT_RECORD) // have one FUNCTOID_IN entry for each fixed input parameter
        FUNCTOID_IN_OPTIONAL(CONNECT_TYPE_ALL_EXCEPT_RECORD) // have one catch-all for optional input parameters
        FUNCTOID_IMPL(SCRIPT_CATEGORY_JSCRIPT, GetSelectorImpl) // 2nd param is member function of CSelector
   END_FUNCTOID
END_FUNCTOID_MAP


BSTR CSelector::GetSelectorImpl ( long nParameters )
{
    // format function signature:  function Selector ( j , val1, val2, val3, ..., valn )
    wchar_t wsz[4096];
    ::wcscpy(wsz, L"function Selector ( ");
    if (nParameters > 0) ::wcscat(wsz, L"j");
    for ( int i = 1;  i < nParameters;  ++ i )
        ::swprintf(wsz+::wcslen(wsz), L", val%d", i);
    ::wcscat(wsz, L" )\r\n");

    // append function body
    ::wcscat(wsz, L"{\n"
                  L"    try\n"
                  L"    {\n"
                  L"        // Normalize the various forms of the input to an integer\n"
                  L"        switch (j.constructor) // let's check the type\n"
                  L"        {\n"
                  L"            case Number:  // make sure any number is integer\n"
                  L"                j = Math.floor(j); // e.g., use 1 if have 1.1\n"
                  L"                break;\n"
                  L"            case Boolean: // use 1 for true and 2 for false\n"
                  L"                j = j ? 1 : 2;\n"
                  L"                break; \n"
                  L"            case String: // string could hold bool or number\n"
                  L"                switch (j.toUpperCase()) \n"
                  L"                {\n"
                  L"                    case \"TRUE\":  j = 1; break;\n"
                  L"                    case \"FALSE\": j = 2; break;\n"
                  L"                    default: j = Math.floor(parseInt(j)); break;\n"
                  L"                 }\n"
                  L"                 break;\n"
                  L"            default:  \n"
                  L"                j = 0; // flag error with invalid index\n"
                  L"                break;\n"
                  L"        }\n"
                  L"        \n"
                  L"        // return the selected value, if any\n"
                  L"        return eval('val' + j);\n"
                  L"    }\n"
                  L"    catch ( x )\n"
                  L"    {\n"
                  L"    }\n"
                  L"    return \"\"; // error return\n"
                  L"}\n");
    return ::SysAllocString(wsz);
}
